function [] = q2A
d2 = 3; %constant
h = [-0.05, -0.04, 0, 0.08, 0.16, 0.22+(d2/1000), 0.25+(d2/1000), 0.22+(d2/1000), 0.16, 0.08, 0, -0.04, -0.05];
 %the given delta response
H = 1:629; %Transfer function H(e^j^w)
amp=1:629; %amplitude of the transfer function
phase=1:629; %phase of the transfer function

for n=1:629 %set all values of H, amp and phase to zero
    H(n) = 0;
    amp(n)=0;
    phase(n)=0;
end

idx = 1;
for w=-pi:.01:pi
    for n=1:13
        H(idx)  = H(idx) + h(n)*exp(-1i*w*n); %fourier transform of h(n)
    end
    amp(idx)  = 20*log10(sqrt(imag(H(idx))^2 + real(H(idx))^2)); %the amplitude of a complex number, |H(jw)|
    phase(idx)=argument(H(idx));%the argument of a complex number, arg(H(jw))
    idx = idx + 1;
end

w=-pi:.01:pi;
subplot(3,1,1); plot(w,H)
title('Fourier Transform of h(t)');
xlabel('frequency [Hz]');
ylabel('amplitude [jw]');
subplot(3,1,2); plot(w,amp)
title('Amplitude of H(jw)');
xlabel('frequency [Hz]');
ylabel('amplitude [dB]');
subplot(3,1,3); plot(w,phase)
title('Phase of H(jw)');
xlabel('frequency [Hz]');
ylabel('phase [rad]');
end

function [out] = argument(num) %this function outputs the argument of a complex number
x = real(num);
y = imag(num);

if x > 0
    out = atan(y/x);
elseif x <  0 && y >= 0
   out = atan(y/x) + pi;
elseif x < 0 && y < 0
   out = atan(y/x) - pi;
elseif x == 0 && y > 0
    out = pi/2;
elseif x == 0 && y < 0
   out = -pi/2;
else
    out = inf;
end
end