function [] = q2B
Xjw = 1:631; %regular plot fourier transform - hits all values
xp = 1:12; %the given signal
limit = 10; %level of approximation
piPer3 = 1.05; %approximation for pi/3 - used for our accuracy level

for n=1:12 %set all xp to zero
    xp(n) = 0;
end
for n=1:631 %set all Xjw to zero
    Xjw(n)=0;
end

idx = 1;
for n=0:11 %calculate the original x_p[n]
    xp(idx) = x_p(n);
    idx = idx + 1;
end

idx = 1;
for w=-3*piPer3:.01:3*piPer3 %run from -2*pi to 2*pi in steps of .01
    for n=-limit:limit
        Xjw(idx) = Xjw(idx) + piPer3*Ck(n)*delta(w-piPer3*n); %DTFT
    end
    idx = idx + 1;
end

n=0:11;
w=-3*piPer3:.01:3*piPer3;
subplot(2,1,1); stem(n,xp)
title('x_p[n] in Discrete Time');
xlabel('time');
ylabel('x_p[n]');
subplot(2,1,2); plot(w,Xjw)
title('Discrete Time Fourier Transform of x_p[n]');
xlabel('frequency [Hz]');
ylabel('X_p(e^j^w)');
end

function [y] = Ck(k) %fourier series of our original x_p[n]
w0 = 2*pi/6;    
y = 1+ exp(-1i*w0*k) + exp(-1i*2*w0*k);
end

function [y] = delta(x) %dirac's delta. an approximation to fit our level of accuracy
    if abs(x) < 0.00001
        y = 1;
    else
        y = 0;
    end
end

function [y] = x_p(n)
N = 6;
if mod(n,N) < N/2
    y = 1;
else
    y = 0;
end
end