function [hper] = q2B2
N = 6; %one period
hper = 1:6; %h_p_e_r[n]
limit = 20; %the level of approximation
Hper = 1:631; %regular plot fourier transform - hits all values
piPer3 = 1.05; %approximation for pi/3 - used for our accuracy level

for n=1:6 %set all hper to zero
    hper(n) = 0;
end
for n=1:631 %set all Hper to zero
    Hper(n) = 0;
end

idx = 1;
for n=0:5 %calculate one hper cycle
    for l=-limit:limit
        hper(idx) = hper(idx) + Hn(n-l*N);
    end
    idx = idx + 1;
end

idx = 1;
for w=-3*piPer3:.01:3*piPer3 %run from -2*pi to 2*pi in steps of .01
    for n=-limit:limit
        Hper(idx) = Hper(idx) + piPer3*Hk(n,hper)*delta(w-piPer3*n); %DTFT
    end
    idx = idx + 1;
end

n=0:5;
w=-3*piPer3:.01:3*piPer3;
subplot(2,1,1); stem(n,hper)
title('h_p_e_r[n] in Discrete Time');
xlabel('time');
ylabel('h_p_e_r[n]');
subplot(2,1,2); plot(w,Hper)
title('Discrete Time Fourier Transform  of h_p_e_r[n]');
xlabel('frequency [Hz]');
ylabel('H_p_e_r(e^j^w)');
end

function [y] = Hn (x) %this function will return 0 if out of bounds of h
d2 = 3;
h = [-0.05, -0.04, 0, 0.08, 0.16, 0.22+(d2/1000), 0.25+(d2/1000), 0.22+(d2/1000), 0.16, 0.08, 0, -0.04, -0.05];

if x >= 1 && x <= 13
    y = h(x);
else
    y = 0;
end
end

function [y] = Hk(x,hper) %fourier series of hper[n]
w0 = 2*pi/6;    
y=0;

for n=1:6
    y = y + hper(n)*exp(-1i*w0*x);
end
end

function [y] = delta(x) %dirac's delta. an approximation to fit our level of accuracy
    if abs(x) < 0.00001
        y = 1;
    else
        y = 0;
    end
end