function [] = q2B3
N=6; %one period
hper = q2B2; %h_p_e_r[n] from the last part
limit = 20; %the level of approximation
fFT = 1:631; %regular plot fourier transform - hits all values
piPer3 = 1.05; %approximation for pi/3 - used for our accuracy level

for n=1:631
    fFT(n) = 0;
end

for n=1:6 %circular convultion of x_p with hper
    yn(n) = Ck(n,N,hper);
end

idx = 1;
for w=-3*piPer3:.01:3*piPer3 %run from -2*pi to 2*pi in steps of .01
    for n=-limit:limit
        fFT(idx) = fFT(idx) + piPer3*Ck(n,N,hper)*delta(w-piPer3*n); %DTFT
    end
    idx = idx + 1;
end

n=1:6;
w=-3*piPer3:.01:3*piPer3;
subplot(2,1,1); stem(n,yn)
title('Circular Convultion of x_p[n] with h_p_e_r[n] in Discrete Time');
xlabel('time');
ylabel('y[n]');
subplot(2,1,2); plot(w,fFT)
title('Discrete Time Fourier Transform  of y[n]');
xlabel('frequency [Hz]');
ylabel('Y(e^j^w)');
end

function [y] = Ak(x) %fourier series of our original x-p[n]
w0 = 2*pi/6;    
y = 1+ exp(-1i*w0*x) + exp(-1i*2*w0*x);
end

function [y] = Bk(x,hper) %fourier series of hper[n]
w0 = 2*pi/6;    
y = 0;

for n=1:6
    y = y + hper(n)*exp(-1i*w0*x);
end
end

function [y] = Ck(n,N,hper) %circular convultion
n = mod(n,N);
y = N*Ak(n)*Bk(n,hper);
end

function [y] = delta(x) %dirac's delta. an approximation to fit our level of accuracy
    if abs(x) < 0.00001
        y = 1;
    else
        y = 0;
    end
end