function [hl] = q2C(M)
lim=15*M; %the number of values after the convultion
Hm = 1:629; %FT of h_m[n]
Hi = 1:629; %FT of h_i[n]
hl = 1:lim; %delta response of h_m[n] (conv) h_i[n]
for n=1:629 %set all Hm, Hi, hl to zero
    Hm(n) = 0;
    Hi(n) = 0;
    if n<=lim
        hl(n)=0;
    end
end

idx = 1;
for w=-pi:.01:pi %run from -pi to pi in steps of .01
    for n=1:lim
        Hm(idx) = Hm(idx) + hm(n,M)*exp(-1i*w*n); %fourier transform of h(n)
        Hi(idx) = Hi(idx) + hi(n,M)*exp(-1i*w*n); %fourier transform of hi(n)
    end
    idx = idx + 1;
end

idx = 1;
for n=1:lim %run from 1 to lim
    for m=-lim:lim
        hl(idx) = hl(idx) + hm(n-m,M)*hi(m,M); %convultion
    end
    idx = idx + 1;
end

Hl = Hm.*Hi; %Tranfer Function

w=-pi:.01:pi;
n=1:lim;
subplot(3,1,1); plot(w,Hm)
title('Fourier Transform of h_m[n] while M = 5');
xlabel('frequency [Hz]');
ylabel('H_m[w]');
subplot(3,1,2); stem(n,hl)
title('Transfer Function h_i[n] (conv) h_m[n]');
xlabel('time');
ylabel('h_l[n]');
subplot(3,1,3); plot(w,Hl)
title('Fourier Transform of h_l[n]');
xlabel('frequency [Hz]');
ylabel('H_l[w]');
end

function [y] = hi (x,M) %return the value of h_i
if x >= 1 && x <= M
    y = 1/M;
else
    y = 0;
end
end

function [y] = hm (x,M) %return the value of h_m
d2 = 3;
h = [-0.05, -0.04, 0, 0.08, 0.16, 0.22+(d2/1000), 0.25+(d2/1000), 0.22+(d2/1000), 0.16, 0.08, 0, -0.04, -0.05];

if (mod(x,M) == 0) && (x >= 1) && (x <= 13*M)
    y = h(x/M);
else 
    y = 0;
end
end