function [hbn,Hbjw] = q2D (M,Wc)
lim=15*M; %the number of values after the convultion
hl = q2C(M); %delta response of the transfer function H_l(e^j^w)
hbn = 1:lim; %delta response of the h_b[n] system
Hbjw = 1:629; %Transfer function of h_b[n]
for n=1:lim %calculate h_b(n)
    hbn(n) = hl(n)*exp(1i*(n-1)*Wc);
end

for n=1:629 %set all Hbjw to zero
    Hbjw(n) = 0;
end

idx = 1;
for w=-pi:.01:pi %run from -pi to pi in steps of .01
    for n=1:lim
        Hbjw(idx)  = Hbjw(idx) + hbn(n)*exp(-1i*w*n); %fourier transform of hb(n)
    end
    idx = idx + 1;
end

n=1:lim;
w=-pi:.01:pi;
subplot(2,1,1); stem(n,hbn)
title('Discrete form of h_b[n]');
xlabel('n');
ylabel('h_b[n]');
subplot(2,1,2); plot(w,Hbjw)
title('Fourier Transform of h_b[n]');
xlabel('w');
ylabel('H_b(e^j^w)');
end