function [] = q2H
d1 = 7; %constant
d2 = 3; %constant
Nch = 3*3^(mod(d1,3)); %given constant; Nch = 9
Nx = 1 + 100*Nch; %given constant; Nx = 901
Bch = 2*pi/Nch; %given constant; Bch ~ 0.698
M = 2*pi/(3*Bch); %given constant; M = 3
Wch = mod(1+d2,Nch)*Bch; %given constant; Wch ~ 2.8
Wx = 2*pi/Nx; %given constant; Wx ~ 7e-3

rn = 1:Nx; %the recieved signal, multiplied by exp(1i*Wch*n)
yn = 1:Nx; %the final signal
xn = 1:Nx;
Xjw = 1:629;
Rjw = 1:629; %FT of the recieved signal

%k = 1; %used for the interrupt signal: sin(Wx*n)*exp(1i*(Wch+k*Bch)*n)

for n=1:Nx %set all values of rn and yn to zero
    rn(n) = 0;
    yn(n) = 0;
end

[vn Vjw] = q2G; %recieve the signal and its FT
[hbn Hbjw] = q2D(M,Wch); %recieve the BPF and its FT
%[intvn intVjw] = q2G; %recieve the interrupt signal and its FT

Rjw = Hbjw.*Vjw; %straightforward calculation of Transfer Function Rjw

for n=1:629 %set all values of Rjw to zero
    Rjw(n) = 0;
end

idx = 1;
for n=1:Nx %calculate rn[n] by vn[n] (conv) hbn[n]
    for m=-Nx:Nx
        rn(idx) = rn(idx) + outOfBounds(vn,n-m,Nx)*outOfBounds(hbn,m,15*M); %convultion
    end
    idx = idx + 1;
end

for n=1:Nx %shift rn back around zero
    rn(n) = rn(n)*exp(-1i*Wch*n);
end

idx = 1;
for w=-pi:.01:pi %run from -pi to pi in steps of .01
    for n=-Nx:Nx
        Rjw(idx) = Rjw(idx) + outOfBounds(rn,n,Nx)*exp(-1i*w*n); %fourier transform of rn*exp(-1i*Wch*n)
    end
    idx = idx + 1;
end

[LPFn LPFjw] = q2D(M,0); %recieve a LPF to clean out the signal

idx = 1;
for n=1:Nx %calculate yn[n] by rn[n] (conv) LPFn[n]
    for m=-Nx:Nx
        yn(idx) = yn(idx) + outOfBounds(rn,n-m,Nx)*outOfBounds(LPFn,m,15*M); %convultion
    end
    idx = idx + 1;
end

yn = -yn; %adjust the amplitude of the recieved and cleaned signal
Yjw = Rjw.*LPFjw; %FT of the recieved and cleaned signal

%rn = abs(rn).^2; %compare the interrupt value of the interrupt signal
end


function [y] = outOfBounds (vector,index,limit) %function that returns a zero when given a value
if index >= 1 && index <= limit                 % that is out of bounds of the array
    y = vector(index);
else
    y = 0;
end
end